t / test-lib-functions.shon commit submodule.c: report the submodule that an error occurs in (ba95d4e)
   1# Library of functions shared by all tests scripts, included by
   2# test-lib.sh.
   3#
   4# Copyright (c) 2005 Junio C Hamano
   5#
   6# This program is free software: you can redistribute it and/or modify
   7# it under the terms of the GNU General Public License as published by
   8# the Free Software Foundation, either version 2 of the License, or
   9# (at your option) any later version.
  10#
  11# This program is distributed in the hope that it will be useful,
  12# but WITHOUT ANY WARRANTY; without even the implied warranty of
  13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  14# GNU General Public License for more details.
  15#
  16# You should have received a copy of the GNU General Public License
  17# along with this program.  If not, see http://www.gnu.org/licenses/ .
  18
  19# The semantics of the editor variables are that of invoking
  20# sh -c "$EDITOR \"$@\"" files ...
  21#
  22# If our trash directory contains shell metacharacters, they will be
  23# interpreted if we just set $EDITOR directly, so do a little dance with
  24# environment variables to work around this.
  25#
  26# In particular, quoting isn't enough, as the path may contain the same quote
  27# that we're using.
  28test_set_editor () {
  29        FAKE_EDITOR="$1"
  30        export FAKE_EDITOR
  31        EDITOR='"$FAKE_EDITOR"'
  32        export EDITOR
  33}
  34
  35test_set_index_version () {
  36    GIT_INDEX_VERSION="$1"
  37    export GIT_INDEX_VERSION
  38}
  39
  40test_decode_color () {
  41        awk '
  42                function name(n) {
  43                        if (n == 0) return "RESET";
  44                        if (n == 1) return "BOLD";
  45                        if (n == 7) return "REVERSE";
  46                        if (n == 30) return "BLACK";
  47                        if (n == 31) return "RED";
  48                        if (n == 32) return "GREEN";
  49                        if (n == 33) return "YELLOW";
  50                        if (n == 34) return "BLUE";
  51                        if (n == 35) return "MAGENTA";
  52                        if (n == 36) return "CYAN";
  53                        if (n == 37) return "WHITE";
  54                        if (n == 40) return "BLACK";
  55                        if (n == 41) return "BRED";
  56                        if (n == 42) return "BGREEN";
  57                        if (n == 43) return "BYELLOW";
  58                        if (n == 44) return "BBLUE";
  59                        if (n == 45) return "BMAGENTA";
  60                        if (n == 46) return "BCYAN";
  61                        if (n == 47) return "BWHITE";
  62                }
  63                {
  64                        while (match($0, /\033\[[0-9;]*m/) != 0) {
  65                                printf "%s<", substr($0, 1, RSTART-1);
  66                                codes = substr($0, RSTART+2, RLENGTH-3);
  67                                if (length(codes) == 0)
  68                                        printf "%s", name(0)
  69                                else {
  70                                        n = split(codes, ary, ";");
  71                                        sep = "";
  72                                        for (i = 1; i <= n; i++) {
  73                                                printf "%s%s", sep, name(ary[i]);
  74                                                sep = ";"
  75                                        }
  76                                }
  77                                printf ">";
  78                                $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
  79                        }
  80                        print
  81                }
  82        '
  83}
  84
  85lf_to_nul () {
  86        perl -pe 'y/\012/\000/'
  87}
  88
  89nul_to_q () {
  90        perl -pe 'y/\000/Q/'
  91}
  92
  93q_to_nul () {
  94        perl -pe 'y/Q/\000/'
  95}
  96
  97q_to_cr () {
  98        tr Q '\015'
  99}
 100
 101q_to_tab () {
 102        tr Q '\011'
 103}
 104
 105qz_to_tab_space () {
 106        tr QZ '\011\040'
 107}
 108
 109append_cr () {
 110        sed -e 's/$/Q/' | tr Q '\015'
 111}
 112
 113remove_cr () {
 114        tr '\015' Q | sed -e 's/Q$//'
 115}
 116
 117# In some bourne shell implementations, the "unset" builtin returns
 118# nonzero status when a variable to be unset was not set in the first
 119# place.
 120#
 121# Use sane_unset when that should not be considered an error.
 122
 123sane_unset () {
 124        unset "$@"
 125        return 0
 126}
 127
 128test_tick () {
 129        if test -z "${test_tick+set}"
 130        then
 131                test_tick=1112911993
 132        else
 133                test_tick=$(($test_tick + 60))
 134        fi
 135        GIT_COMMITTER_DATE="$test_tick -0700"
 136        GIT_AUTHOR_DATE="$test_tick -0700"
 137        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 138}
 139
 140# Stop execution and start a shell. This is useful for debugging tests.
 141#
 142# Be sure to remove all invocations of this command before submitting.
 143
 144test_pause () {
 145        "$SHELL_PATH" <&6 >&5 2>&7
 146}
 147
 148# Wrap git in gdb. Adding this to a command can make it easier to
 149# understand what is going on in a failing test.
 150#
 151# Example: "debug git checkout master".
 152debug () {
 153         GIT_TEST_GDB=1 "$@" <&6 >&5 2>&7
 154}
 155
 156# Call test_commit with the arguments
 157# [-C <directory>] <message> [<file> [<contents> [<tag>]]]"
 158#
 159# This will commit a file with the given contents and the given commit
 160# message, and tag the resulting commit with the given tag name.
 161#
 162# <file>, <contents>, and <tag> all default to <message>.
 163#
 164# If the first argument is "-C", the second argument is used as a path for
 165# the git invocations.
 166
 167test_commit () {
 168        notick= &&
 169        signoff= &&
 170        indir= &&
 171        while test $# != 0
 172        do
 173                case "$1" in
 174                --notick)
 175                        notick=yes
 176                        ;;
 177                --signoff)
 178                        signoff="$1"
 179                        ;;
 180                -C)
 181                        indir="$2"
 182                        shift
 183                        ;;
 184                *)
 185                        break
 186                        ;;
 187                esac
 188                shift
 189        done &&
 190        indir=${indir:+"$indir"/} &&
 191        file=${2:-"$1.t"} &&
 192        echo "${3-$1}" > "$indir$file" &&
 193        git ${indir:+ -C "$indir"} add "$file" &&
 194        if test -z "$notick"
 195        then
 196                test_tick
 197        fi &&
 198        git ${indir:+ -C "$indir"} commit $signoff -m "$1" &&
 199        git ${indir:+ -C "$indir"} tag "${4:-$1}"
 200}
 201
 202# Call test_merge with the arguments "<message> <commit>", where <commit>
 203# can be a tag pointing to the commit-to-merge.
 204
 205test_merge () {
 206        test_tick &&
 207        git merge -m "$1" "$2" &&
 208        git tag "$1"
 209}
 210
 211# This function helps systems where core.filemode=false is set.
 212# Use it instead of plain 'chmod +x' to set or unset the executable bit
 213# of a file in the working directory and add it to the index.
 214
 215test_chmod () {
 216        chmod "$@" &&
 217        git update-index --add "--chmod=$@"
 218}
 219
 220# Get the modebits from a file.
 221test_modebits () {
 222        ls -l "$1" | sed -e 's|^\(..........\).*|\1|'
 223}
 224
 225# Unset a configuration variable, but don't fail if it doesn't exist.
 226test_unconfig () {
 227        config_dir=
 228        if test "$1" = -C
 229        then
 230                shift
 231                config_dir=$1
 232                shift
 233        fi
 234        git ${config_dir:+-C "$config_dir"} config --unset-all "$@"
 235        config_status=$?
 236        case "$config_status" in
 237        5) # ok, nothing to unset
 238                config_status=0
 239                ;;
 240        esac
 241        return $config_status
 242}
 243
 244# Set git config, automatically unsetting it after the test is over.
 245test_config () {
 246        config_dir=
 247        if test "$1" = -C
 248        then
 249                shift
 250                config_dir=$1
 251                shift
 252        fi
 253        test_when_finished "test_unconfig ${config_dir:+-C '$config_dir'} '$1'" &&
 254        git ${config_dir:+-C "$config_dir"} config "$@"
 255}
 256
 257test_config_global () {
 258        test_when_finished "test_unconfig --global '$1'" &&
 259        git config --global "$@"
 260}
 261
 262write_script () {
 263        {
 264                echo "#!${2-"$SHELL_PATH"}" &&
 265                cat
 266        } >"$1" &&
 267        chmod +x "$1"
 268}
 269
 270# Use test_set_prereq to tell that a particular prerequisite is available.
 271# The prerequisite can later be checked for in two ways:
 272#
 273# - Explicitly using test_have_prereq.
 274#
 275# - Implicitly by specifying the prerequisite tag in the calls to
 276#   test_expect_{success,failure,code}.
 277#
 278# The single parameter is the prerequisite tag (a simple word, in all
 279# capital letters by convention).
 280
 281test_set_prereq () {
 282        satisfied_prereq="$satisfied_prereq$1 "
 283}
 284satisfied_prereq=" "
 285lazily_testable_prereq= lazily_tested_prereq=
 286
 287# Usage: test_lazy_prereq PREREQ 'script'
 288test_lazy_prereq () {
 289        lazily_testable_prereq="$lazily_testable_prereq$1 "
 290        eval test_prereq_lazily_$1=\$2
 291}
 292
 293test_run_lazy_prereq_ () {
 294        script='
 295mkdir -p "$TRASH_DIRECTORY/prereq-test-dir" &&
 296(
 297        cd "$TRASH_DIRECTORY/prereq-test-dir" &&'"$2"'
 298)'
 299        say >&3 "checking prerequisite: $1"
 300        say >&3 "$script"
 301        test_eval_ "$script"
 302        eval_ret=$?
 303        rm -rf "$TRASH_DIRECTORY/prereq-test-dir"
 304        if test "$eval_ret" = 0; then
 305                say >&3 "prerequisite $1 ok"
 306        else
 307                say >&3 "prerequisite $1 not satisfied"
 308        fi
 309        return $eval_ret
 310}
 311
 312test_have_prereq () {
 313        # prerequisites can be concatenated with ','
 314        save_IFS=$IFS
 315        IFS=,
 316        set -- $*
 317        IFS=$save_IFS
 318
 319        total_prereq=0
 320        ok_prereq=0
 321        missing_prereq=
 322
 323        for prerequisite
 324        do
 325                case "$prerequisite" in
 326                !*)
 327                        negative_prereq=t
 328                        prerequisite=${prerequisite#!}
 329                        ;;
 330                *)
 331                        negative_prereq=
 332                esac
 333
 334                case " $lazily_tested_prereq " in
 335                *" $prerequisite "*)
 336                        ;;
 337                *)
 338                        case " $lazily_testable_prereq " in
 339                        *" $prerequisite "*)
 340                                eval "script=\$test_prereq_lazily_$prerequisite" &&
 341                                if test_run_lazy_prereq_ "$prerequisite" "$script"
 342                                then
 343                                        test_set_prereq $prerequisite
 344                                fi
 345                                lazily_tested_prereq="$lazily_tested_prereq$prerequisite "
 346                        esac
 347                        ;;
 348                esac
 349
 350                total_prereq=$(($total_prereq + 1))
 351                case "$satisfied_prereq" in
 352                *" $prerequisite "*)
 353                        satisfied_this_prereq=t
 354                        ;;
 355                *)
 356                        satisfied_this_prereq=
 357                esac
 358
 359                case "$satisfied_this_prereq,$negative_prereq" in
 360                t,|,t)
 361                        ok_prereq=$(($ok_prereq + 1))
 362                        ;;
 363                *)
 364                        # Keep a list of missing prerequisites; restore
 365                        # the negative marker if necessary.
 366                        prerequisite=${negative_prereq:+!}$prerequisite
 367                        if test -z "$missing_prereq"
 368                        then
 369                                missing_prereq=$prerequisite
 370                        else
 371                                missing_prereq="$prerequisite,$missing_prereq"
 372                        fi
 373                esac
 374        done
 375
 376        test $total_prereq = $ok_prereq
 377}
 378
 379test_declared_prereq () {
 380        case ",$test_prereq," in
 381        *,$1,*)
 382                return 0
 383                ;;
 384        esac
 385        return 1
 386}
 387
 388test_verify_prereq () {
 389        test -z "$test_prereq" ||
 390        expr >/dev/null "$test_prereq" : '[A-Z0-9_,!]*$' ||
 391        error "bug in the test script: '$test_prereq' does not look like a prereq"
 392}
 393
 394test_expect_failure () {
 395        test_start_
 396        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 397        test "$#" = 2 ||
 398        error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
 399        test_verify_prereq
 400        export test_prereq
 401        if ! test_skip "$@"
 402        then
 403                say >&3 "checking known breakage: $2"
 404                if test_run_ "$2" expecting_failure
 405                then
 406                        test_known_broken_ok_ "$1"
 407                else
 408                        test_known_broken_failure_ "$1"
 409                fi
 410        fi
 411        test_finish_
 412}
 413
 414test_expect_success () {
 415        test_start_
 416        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 417        test "$#" = 2 ||
 418        error "bug in the test script: not 2 or 3 parameters to test-expect-success"
 419        test_verify_prereq
 420        export test_prereq
 421        if ! test_skip "$@"
 422        then
 423                say >&3 "expecting success: $2"
 424                if test_run_ "$2"
 425                then
 426                        test_ok_ "$1"
 427                else
 428                        test_failure_ "$@"
 429                fi
 430        fi
 431        test_finish_
 432}
 433
 434# test_external runs external test scripts that provide continuous
 435# test output about their progress, and succeeds/fails on
 436# zero/non-zero exit code.  It outputs the test output on stdout even
 437# in non-verbose mode, and announces the external script with "# run
 438# <n>: ..." before running it.  When providing relative paths, keep in
 439# mind that all scripts run in "trash directory".
 440# Usage: test_external description command arguments...
 441# Example: test_external 'Perl API' perl ../path/to/test.pl
 442test_external () {
 443        test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
 444        test "$#" = 3 ||
 445        error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
 446        descr="$1"
 447        shift
 448        test_verify_prereq
 449        export test_prereq
 450        if ! test_skip "$descr" "$@"
 451        then
 452                # Announce the script to reduce confusion about the
 453                # test output that follows.
 454                say_color "" "# run $test_count: $descr ($*)"
 455                # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
 456                # to be able to use them in script
 457                export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
 458                # Run command; redirect its stderr to &4 as in
 459                # test_run_, but keep its stdout on our stdout even in
 460                # non-verbose mode.
 461                "$@" 2>&4
 462                if test "$?" = 0
 463                then
 464                        if test $test_external_has_tap -eq 0; then
 465                                test_ok_ "$descr"
 466                        else
 467                                say_color "" "# test_external test $descr was ok"
 468                                test_success=$(($test_success + 1))
 469                        fi
 470                else
 471                        if test $test_external_has_tap -eq 0; then
 472                                test_failure_ "$descr" "$@"
 473                        else
 474                                say_color error "# test_external test $descr failed: $@"
 475                                test_failure=$(($test_failure + 1))
 476                        fi
 477                fi
 478        fi
 479}
 480
 481# Like test_external, but in addition tests that the command generated
 482# no output on stderr.
 483test_external_without_stderr () {
 484        # The temporary file has no (and must have no) security
 485        # implications.
 486        tmp=${TMPDIR:-/tmp}
 487        stderr="$tmp/git-external-stderr.$$.tmp"
 488        test_external "$@" 4> "$stderr"
 489        test -f "$stderr" || error "Internal error: $stderr disappeared."
 490        descr="no stderr: $1"
 491        shift
 492        say >&3 "# expecting no stderr from previous command"
 493        if test ! -s "$stderr"
 494        then
 495                rm "$stderr"
 496
 497                if test $test_external_has_tap -eq 0; then
 498                        test_ok_ "$descr"
 499                else
 500                        say_color "" "# test_external_without_stderr test $descr was ok"
 501                        test_success=$(($test_success + 1))
 502                fi
 503        else
 504                if test "$verbose" = t
 505                then
 506                        output=$(echo; echo "# Stderr is:"; cat "$stderr")
 507                else
 508                        output=
 509                fi
 510                # rm first in case test_failure exits.
 511                rm "$stderr"
 512                if test $test_external_has_tap -eq 0; then
 513                        test_failure_ "$descr" "$@" "$output"
 514                else
 515                        say_color error "# test_external_without_stderr test $descr failed: $@: $output"
 516                        test_failure=$(($test_failure + 1))
 517                fi
 518        fi
 519}
 520
 521# debugging-friendly alternatives to "test [-f|-d|-e]"
 522# The commands test the existence or non-existence of $1. $2 can be
 523# given to provide a more precise diagnosis.
 524test_path_is_file () {
 525        if ! test -f "$1"
 526        then
 527                echo "File $1 doesn't exist. $2"
 528                false
 529        fi
 530}
 531
 532test_path_is_dir () {
 533        if ! test -d "$1"
 534        then
 535                echo "Directory $1 doesn't exist. $2"
 536                false
 537        fi
 538}
 539
 540# Check if the directory exists and is empty as expected, barf otherwise.
 541test_dir_is_empty () {
 542        test_path_is_dir "$1" &&
 543        if test -n "$(ls -a1 "$1" | egrep -v '^\.\.?$')"
 544        then
 545                echo "Directory '$1' is not empty, it contains:"
 546                ls -la "$1"
 547                return 1
 548        fi
 549}
 550
 551test_path_is_missing () {
 552        if test -e "$1"
 553        then
 554                echo "Path exists:"
 555                ls -ld "$1"
 556                if test $# -ge 1
 557                then
 558                        echo "$*"
 559                fi
 560                false
 561        fi
 562}
 563
 564# test_line_count checks that a file has the number of lines it
 565# ought to. For example:
 566#
 567#       test_expect_success 'produce exactly one line of output' '
 568#               do something >output &&
 569#               test_line_count = 1 output
 570#       '
 571#
 572# is like "test $(wc -l <output) = 1" except that it passes the
 573# output through when the number of lines is wrong.
 574
 575test_line_count () {
 576        if test $# != 3
 577        then
 578                error "bug in the test script: not 3 parameters to test_line_count"
 579        elif ! test $(wc -l <"$3") "$1" "$2"
 580        then
 581                echo "test_line_count: line count for $3 !$1 $2"
 582                cat "$3"
 583                return 1
 584        fi
 585}
 586
 587# Returns success if a comma separated string of keywords ($1) contains a
 588# given keyword ($2).
 589# Examples:
 590# `list_contains "foo,bar" bar` returns 0
 591# `list_contains "foo" bar` returns 1
 592
 593list_contains () {
 594        case ",$1," in
 595        *,$2,*)
 596                return 0
 597                ;;
 598        esac
 599        return 1
 600}
 601
 602# This is not among top-level (test_expect_success | test_expect_failure)
 603# but is a prefix that can be used in the test script, like:
 604#
 605#       test_expect_success 'complain and die' '
 606#           do something &&
 607#           do something else &&
 608#           test_must_fail git checkout ../outerspace
 609#       '
 610#
 611# Writing this as "! git checkout ../outerspace" is wrong, because
 612# the failure could be due to a segv.  We want a controlled failure.
 613#
 614# Accepts the following options:
 615#
 616#   ok=<signal-name>[,<...>]:
 617#     Don't treat an exit caused by the given signal as error.
 618#     Multiple signals can be specified as a comma separated list.
 619#     Currently recognized signal names are: sigpipe, success.
 620#     (Don't use 'success', use 'test_might_fail' instead.)
 621
 622test_must_fail () {
 623        case "$1" in
 624        ok=*)
 625                _test_ok=${1#ok=}
 626                shift
 627                ;;
 628        *)
 629                _test_ok=
 630                ;;
 631        esac
 632        "$@"
 633        exit_code=$?
 634        if test $exit_code -eq 0 && ! list_contains "$_test_ok" success
 635        then
 636                echo >&2 "test_must_fail: command succeeded: $*"
 637                return 1
 638        elif test_match_signal 13 $exit_code && list_contains "$_test_ok" sigpipe
 639        then
 640                return 0
 641        elif test $exit_code -gt 129 && test $exit_code -le 192
 642        then
 643                echo >&2 "test_must_fail: died by signal $(($exit_code - 128)): $*"
 644                return 1
 645        elif test $exit_code -eq 127
 646        then
 647                echo >&2 "test_must_fail: command not found: $*"
 648                return 1
 649        elif test $exit_code -eq 126
 650        then
 651                echo >&2 "test_must_fail: valgrind error: $*"
 652                return 1
 653        fi
 654        return 0
 655}
 656
 657# Similar to test_must_fail, but tolerates success, too.  This is
 658# meant to be used in contexts like:
 659#
 660#       test_expect_success 'some command works without configuration' '
 661#               test_might_fail git config --unset all.configuration &&
 662#               do something
 663#       '
 664#
 665# Writing "git config --unset all.configuration || :" would be wrong,
 666# because we want to notice if it fails due to segv.
 667#
 668# Accepts the same options as test_must_fail.
 669
 670test_might_fail () {
 671        test_must_fail ok=success "$@"
 672}
 673
 674# Similar to test_must_fail and test_might_fail, but check that a
 675# given command exited with a given exit code. Meant to be used as:
 676#
 677#       test_expect_success 'Merge with d/f conflicts' '
 678#               test_expect_code 1 git merge "merge msg" B master
 679#       '
 680
 681test_expect_code () {
 682        want_code=$1
 683        shift
 684        "$@"
 685        exit_code=$?
 686        if test $exit_code = $want_code
 687        then
 688                return 0
 689        fi
 690
 691        echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
 692        return 1
 693}
 694
 695# test_cmp is a helper function to compare actual and expected output.
 696# You can use it like:
 697#
 698#       test_expect_success 'foo works' '
 699#               echo expected >expected &&
 700#               foo >actual &&
 701#               test_cmp expected actual
 702#       '
 703#
 704# This could be written as either "cmp" or "diff -u", but:
 705# - cmp's output is not nearly as easy to read as diff -u
 706# - not all diff versions understand "-u"
 707
 708test_cmp() {
 709        $GIT_TEST_CMP "$@"
 710}
 711
 712# test_cmp_bin - helper to compare binary files
 713
 714test_cmp_bin() {
 715        cmp "$@"
 716}
 717
 718# Use this instead of test_cmp to compare files that contain expected and
 719# actual output from git commands that can be translated.  When running
 720# under GETTEXT_POISON this pretends that the command produced expected
 721# results.
 722test_i18ncmp () {
 723        test -n "$GETTEXT_POISON" || test_cmp "$@"
 724}
 725
 726# Use this instead of "grep expected-string actual" to see if the
 727# output from a git command that can be translated either contains an
 728# expected string, or does not contain an unwanted one.  When running
 729# under GETTEXT_POISON this pretends that the command produced expected
 730# results.
 731test_i18ngrep () {
 732        eval "last_arg=\${$#}"
 733
 734        test -f "$last_arg" ||
 735        error "bug in the test script: test_i18ngrep requires a file" \
 736              "to read as the last parameter"
 737
 738        if test $# -lt 2 ||
 739           { test "x!" = "x$1" && test $# -lt 3 ; }
 740        then
 741                error "bug in the test script: too few parameters to test_i18ngrep"
 742        fi
 743
 744        if test -n "$GETTEXT_POISON"
 745        then
 746                # pretend success
 747                return 0
 748        fi
 749
 750        if test "x!" = "x$1"
 751        then
 752                shift
 753                ! grep "$@" && return 0
 754
 755                echo >&2 "error: '! grep $@' did find a match in:"
 756        else
 757                grep "$@" && return 0
 758
 759                echo >&2 "error: 'grep $@' didn't find a match in:"
 760        fi
 761
 762        if test -s "$last_arg"
 763        then
 764                cat >&2 "$last_arg"
 765        else
 766                echo >&2 "<File '$last_arg' is empty>"
 767        fi
 768
 769        return 1
 770}
 771
 772# Call any command "$@" but be more verbose about its
 773# failure. This is handy for commands like "test" which do
 774# not output anything when they fail.
 775verbose () {
 776        "$@" && return 0
 777        echo >&2 "command failed: $(git rev-parse --sq-quote "$@")"
 778        return 1
 779}
 780
 781# Check if the file expected to be empty is indeed empty, and barfs
 782# otherwise.
 783
 784test_must_be_empty () {
 785        if test -s "$1"
 786        then
 787                echo "'$1' is not empty, it contains:"
 788                cat "$1"
 789                return 1
 790        fi
 791}
 792
 793# Tests that its two parameters refer to the same revision
 794test_cmp_rev () {
 795        git rev-parse --verify "$1" >expect.rev &&
 796        git rev-parse --verify "$2" >actual.rev &&
 797        test_cmp expect.rev actual.rev
 798}
 799
 800# Print a sequence of integers in increasing order, either with
 801# two arguments (start and end):
 802#
 803#     test_seq 1 5 -- outputs 1 2 3 4 5 one line at a time
 804#
 805# or with one argument (end), in which case it starts counting
 806# from 1.
 807
 808test_seq () {
 809        case $# in
 810        1)      set 1 "$@" ;;
 811        2)      ;;
 812        *)      error "bug in the test script: not 1 or 2 parameters to test_seq" ;;
 813        esac
 814        test_seq_counter__=$1
 815        while test "$test_seq_counter__" -le "$2"
 816        do
 817                echo "$test_seq_counter__"
 818                test_seq_counter__=$(( $test_seq_counter__ + 1 ))
 819        done
 820}
 821
 822# This function can be used to schedule some commands to be run
 823# unconditionally at the end of the test to restore sanity:
 824#
 825#       test_expect_success 'test core.capslock' '
 826#               git config core.capslock true &&
 827#               test_when_finished "git config --unset core.capslock" &&
 828#               hello world
 829#       '
 830#
 831# That would be roughly equivalent to
 832#
 833#       test_expect_success 'test core.capslock' '
 834#               git config core.capslock true &&
 835#               hello world
 836#               git config --unset core.capslock
 837#       '
 838#
 839# except that the greeting and config --unset must both succeed for
 840# the test to pass.
 841#
 842# Note that under --immediate mode, no clean-up is done to help diagnose
 843# what went wrong.
 844
 845test_when_finished () {
 846        # We cannot detect when we are in a subshell in general, but by
 847        # doing so on Bash is better than nothing (the test will
 848        # silently pass on other shells).
 849        test "${BASH_SUBSHELL-0}" = 0 ||
 850        error "bug in test script: test_when_finished does nothing in a subshell"
 851        test_cleanup="{ $*
 852                } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
 853}
 854
 855# Most tests can use the created repository, but some may need to create more.
 856# Usage: test_create_repo <directory>
 857test_create_repo () {
 858        test "$#" = 1 ||
 859        error "bug in the test script: not 1 parameter to test-create-repo"
 860        repo="$1"
 861        mkdir -p "$repo"
 862        (
 863                cd "$repo" || error "Cannot setup test environment"
 864                "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
 865                error "cannot run git init -- have you built things yet?"
 866                mv .git/hooks .git/hooks-disabled
 867        ) || exit
 868}
 869
 870# This function helps on symlink challenged file systems when it is not
 871# important that the file system entry is a symbolic link.
 872# Use test_ln_s_add instead of "ln -s x y && git add y" to add a
 873# symbolic link entry y to the index.
 874
 875test_ln_s_add () {
 876        if test_have_prereq SYMLINKS
 877        then
 878                ln -s "$1" "$2" &&
 879                git update-index --add "$2"
 880        else
 881                printf '%s' "$1" >"$2" &&
 882                ln_s_obj=$(git hash-object -w "$2") &&
 883                git update-index --add --cacheinfo 120000 $ln_s_obj "$2" &&
 884                # pick up stat info from the file
 885                git update-index "$2"
 886        fi
 887}
 888
 889# This function writes out its parameters, one per line
 890test_write_lines () {
 891        printf "%s\n" "$@"
 892}
 893
 894perl () {
 895        command "$PERL_PATH" "$@"
 896}
 897
 898# Is the value one of the various ways to spell a boolean true/false?
 899test_normalize_bool () {
 900        git -c magic.variable="$1" config --bool magic.variable 2>/dev/null
 901}
 902
 903# Given a variable $1, normalize the value of it to one of "true",
 904# "false", or "auto" and store the result to it.
 905#
 906#     test_tristate GIT_TEST_HTTPD
 907#
 908# A variable set to an empty string is set to 'false'.
 909# A variable set to 'false' or 'auto' keeps its value.
 910# Anything else is set to 'true'.
 911# An unset variable defaults to 'auto'.
 912#
 913# The last rule is to allow people to set the variable to an empty
 914# string and export it to decline testing the particular feature
 915# for versions both before and after this change.  We used to treat
 916# both unset and empty variable as a signal for "do not test" and
 917# took any non-empty string as "please test".
 918
 919test_tristate () {
 920        if eval "test x\"\${$1+isset}\" = xisset"
 921        then
 922                # explicitly set
 923                eval "
 924                        case \"\$$1\" in
 925                        '')     $1=false ;;
 926                        auto)   ;;
 927                        *)      $1=\$(test_normalize_bool \$$1 || echo true) ;;
 928                        esac
 929                "
 930        else
 931                eval "$1=auto"
 932        fi
 933}
 934
 935# Exit the test suite, either by skipping all remaining tests or by
 936# exiting with an error. If "$1" is "auto", we then we assume we were
 937# opportunistically trying to set up some tests and we skip. If it is
 938# "true", then we report a failure.
 939#
 940# The error/skip message should be given by $2.
 941#
 942test_skip_or_die () {
 943        case "$1" in
 944        auto)
 945                skip_all=$2
 946                test_done
 947                ;;
 948        true)
 949                error "$2"
 950                ;;
 951        *)
 952                error "BUG: test tristate is '$1' (real error: $2)"
 953        esac
 954}
 955
 956# The following mingw_* functions obey POSIX shell syntax, but are actually
 957# bash scripts, and are meant to be used only with bash on Windows.
 958
 959# A test_cmp function that treats LF and CRLF equal and avoids to fork
 960# diff when possible.
 961mingw_test_cmp () {
 962        # Read text into shell variables and compare them. If the results
 963        # are different, use regular diff to report the difference.
 964        local test_cmp_a= test_cmp_b=
 965
 966        # When text came from stdin (one argument is '-') we must feed it
 967        # to diff.
 968        local stdin_for_diff=
 969
 970        # Since it is difficult to detect the difference between an
 971        # empty input file and a failure to read the files, we go straight
 972        # to diff if one of the inputs is empty.
 973        if test -s "$1" && test -s "$2"
 974        then
 975                # regular case: both files non-empty
 976                mingw_read_file_strip_cr_ test_cmp_a <"$1"
 977                mingw_read_file_strip_cr_ test_cmp_b <"$2"
 978        elif test -s "$1" && test "$2" = -
 979        then
 980                # read 2nd file from stdin
 981                mingw_read_file_strip_cr_ test_cmp_a <"$1"
 982                mingw_read_file_strip_cr_ test_cmp_b
 983                stdin_for_diff='<<<"$test_cmp_b"'
 984        elif test "$1" = - && test -s "$2"
 985        then
 986                # read 1st file from stdin
 987                mingw_read_file_strip_cr_ test_cmp_a
 988                mingw_read_file_strip_cr_ test_cmp_b <"$2"
 989                stdin_for_diff='<<<"$test_cmp_a"'
 990        fi
 991        test -n "$test_cmp_a" &&
 992        test -n "$test_cmp_b" &&
 993        test "$test_cmp_a" = "$test_cmp_b" ||
 994        eval "diff -u \"\$@\" $stdin_for_diff"
 995}
 996
 997# $1 is the name of the shell variable to fill in
 998mingw_read_file_strip_cr_ () {
 999        # Read line-wise using LF as the line separator
1000        # and use IFS to strip CR.
1001        local line
1002        while :
1003        do
1004                if IFS=$'\r' read -r -d $'\n' line
1005                then
1006                        # good
1007                        line=$line$'\n'
1008                else
1009                        # we get here at EOF, but also if the last line
1010                        # was not terminated by LF; in the latter case,
1011                        # some text was read
1012                        if test -z "$line"
1013                        then
1014                                # EOF, really
1015                                break
1016                        fi
1017                fi
1018                eval "$1=\$$1\$line"
1019        done
1020}
1021
1022# Like "env FOO=BAR some-program", but run inside a subshell, which means
1023# it also works for shell functions (though those functions cannot impact
1024# the environment outside of the test_env invocation).
1025test_env () {
1026        (
1027                while test $# -gt 0
1028                do
1029                        case "$1" in
1030                        *=*)
1031                                eval "${1%%=*}=\${1#*=}"
1032                                eval "export ${1%%=*}"
1033                                shift
1034                                ;;
1035                        *)
1036                                "$@"
1037                                exit
1038                                ;;
1039                        esac
1040                done
1041        )
1042}
1043
1044# Returns true if the numeric exit code in "$2" represents the expected signal
1045# in "$1". Signals should be given numerically.
1046test_match_signal () {
1047        if test "$2" = "$((128 + $1))"
1048        then
1049                # POSIX
1050                return 0
1051        elif test "$2" = "$((256 + $1))"
1052        then
1053                # ksh
1054                return 0
1055        fi
1056        return 1
1057}
1058
1059# Read up to "$1" bytes (or to EOF) from stdin and write them to stdout.
1060test_copy_bytes () {
1061        perl -e '
1062                my $len = $ARGV[1];
1063                while ($len > 0) {
1064                        my $s;
1065                        my $nread = sysread(STDIN, $s, $len);
1066                        die "cannot read: $!" unless defined($nread);
1067                        last unless $nread;
1068                        print $s;
1069                        $len -= $nread;
1070                }
1071        ' - "$1"
1072}
1073
1074# run "$@" inside a non-git directory
1075nongit () {
1076        test -d non-repo ||
1077        mkdir non-repo ||
1078        return 1
1079
1080        (
1081                GIT_CEILING_DIRECTORIES=$(pwd) &&
1082                export GIT_CEILING_DIRECTORIES &&
1083                cd non-repo &&
1084                "$@"
1085        )
1086}
1087
1088# convert stdin to pktline representation; note that empty input becomes an
1089# empty packet, not a flush packet (for that you can just print 0000 yourself).
1090packetize() {
1091        cat >packetize.tmp &&
1092        len=$(wc -c <packetize.tmp) &&
1093        printf '%04x%s' "$(($len + 4))" &&
1094        cat packetize.tmp &&
1095        rm -f packetize.tmp
1096}
1097
1098# Parse the input as a series of pktlines, writing the result to stdout.
1099# Sideband markers are removed automatically, and the output is routed to
1100# stderr if appropriate.
1101#
1102# NUL bytes are converted to "\\0" for ease of parsing with text tools.
1103depacketize () {
1104        perl -e '
1105                while (read(STDIN, $len, 4) == 4) {
1106                        if ($len eq "0000") {
1107                                print "FLUSH\n";
1108                        } else {
1109                                read(STDIN, $buf, hex($len) - 4);
1110                                $buf =~ s/\0/\\0/g;
1111                                if ($buf =~ s/^[\x2\x3]//) {
1112                                        print STDERR $buf;
1113                                } else {
1114                                        $buf =~ s/^\x1//;
1115                                        print $buf;
1116                                }
1117                        }
1118                }
1119        '
1120}